function  [D,Bt,Ct] = MinOnlineRDL2(D,signal,BETAs,B,C , IterMethod )
% This code is for online IRLS Dictionary Learning
% Data Sep 7 , 2011
% Coder Cewu Lu CUHK
% Input Dictionary : D  , two update matrix B ,C
% singal is observed vector , BETA is sparse coding result
% Output update result Dt, Bt, Ct

W = eye(size(BETAs,1));


%%%%  Parameter   %%%%%
tol = 1e-6;
MaxIter = 200;
%%%%%%%%%%%%%%%%%%%%%%%
 
 
    
 
  
 

Iter = 0; dif = 10^10;
W = eye(size(BETAs,1));
while tol < dif 
    DLast = D ;
    Iter = Iter + 1;
    if Iter == MaxIter
        break;
    end
    Bt = B;
    Ct = C;
    for ii = 1 : size(signal,1)
      %if Iter  ~= 1 
       W =  reweighted(signal(ii,:)',D(ii,:)', BETAs);
      %end
      Ct(ii).m =  Ct(ii).m  +  BETAs' * W * BETAs;
      Bt(ii).m =  Bt(ii).m  +  BETAs' * (W*signal(ii,:)');
      if 1 == IterMethod
       D(ii,:) = (inv(Ct(ii).m + (1e-8)*eye(size(Ct(ii).m)) )*Bt(ii).m)';
      else
       D(ii,:) =    NewtonMethod(Ct(ii).m,Bt(ii).m,D(ii,:)');
      end
    end
    
    dif = mean(abs(DLast(:) - D(:) ));
  
end
 
 
end

function Dline = NewtonMethod(A,b,Init)
  
    Dline = Init;
    tol = 1e-2;
    MaxIter = 10;
    Iter = 0; dif = 10^10;
    while tol < dif 
      DLast = Dline ;
      Iter = Iter + 1;
      if Iter == MaxIter
         break;
       end
       d = A*Dline - b;
       a = -d'*A*d/(d'*A'*A*d);
       Dline =  Dline + a*(A*Dline - b);
       dif = mean(abs(DLast(:) - Dline(:) ));
    end
    Dline = Dline';
 

end



function W =  reweighted(sLine,DLine, BETA)
   deta = 0.0000001;
   r = abs(sLine -  BETA*DLine );
   W = eye(length(r));
   for ii = 1 : length(r)
       W(ii,ii) = 1/sqrt(abs(r(ii))^2 + deta);
   end

end